{% import 'arty_basic_node/cmake_header_macro.jinja' as header_macros %}
{{ header_macros.generate_do_not_edit(generation_date, the_arquetype, archetype.version) }}

cmake_minimum_required(VERSION 3.8)

project({{ project.name }})

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# Common dependencies used in the template
find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)

# User's dependencies from manifest
{% for dependency in dependencies %}
find_package({{ dependency }} REQUIRED)
{% endfor %}

include_directories(
  include
  include/${PROJECT_NAME}
)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

# Source files
set(SOURCES src/node_gen.cpp src/trigger.cpp)

# Add internal source files
file(GLOB INTERNAL_SOURCES "src/internal/*.cpp")

add_library(${PROJECT_NAME}_component SHARED ${SOURCES} ${INTERNAL_SOURCES})
ament_target_dependencies(${PROJECT_NAME}_component rclcpp rclcpp_components {% for dependency in dependencies %}{{ dependency }} {% endfor %})

rclcpp_components_register_node(
	${PROJECT_NAME}_component
	PLUGIN "${PROJECT_NAME}::node"
	EXECUTABLE ${PROJECT_NAME}
)

ament_export_targets(export_${PROJECT_NAME}_component)
install(
	TARGETS ${PROJECT_NAME}_component
	EXPORT export_${PROJECT_NAME}_component
	ARCHIVE DESTINATION lib
	LIBRARY DESTINATION lib
	RUNTIME DESTINATION lib
)

ament_package()